<template>
  <v-card class="mx-auto" max-width="344">
    <v-card-title> {{ props.registrationNumber }} </v-card-title>

    <v-card-subtitle>
      {{ props.startDate }} - {{ props.endDate }}
    </v-card-subtitle>

    <v-card-text>
      {{ props.category }}
      {{ props.make }}
      {{ props.model }}
      {{ props.fuelType }}
      {{ props.pricePerDay }}
    </v-card-text>

    <v-card-actions>
      <v-btn
        @click="removeBooking(props.registrationNumber)"
        color="orange-lighten-2"
        variant="text"
      >
        Remove
      </v-btn>

      <v-spacer></v-spacer>

      <v-btn
        :icon="show ? 'mdi-chevron-up' : 'mdi-chevron-down'"
        @click="show = !show"
      ></v-btn>
    </v-card-actions>

    <v-expand-transition>
      <div v-show="show">
        <v-divider></v-divider>

        <v-card-text>
          {{ props.make }}
        </v-card-text>
      </div>
    </v-expand-transition>
  </v-card>
</template>

<script lang="ts">
import { useBookedStore } from "@/stores/booked";
import type { Ref } from "vue";
import { defineComponent, ref } from "vue";

export default defineComponent({
  props: {
    registrationNumber: {
      type: String,
    },
    category: {
      type: String,
    },
    make: {
      type: String,
    },
    model: {
      type: String,
    },
    fuelType: {
      type: String,
    },
    pricePerDay: {
      type: String,
    },
    startDate: {
      type: String,
    },
    endDate: {
      type: String,
    },
  },
  setup(props) {
    const show: Ref<boolean> = ref(false);
    const booked = useBookedStore();

    const removeBooking = (registrationNumber: string | undefined) => {
      booked.removeBooking(registrationNumber);
    };

    return { show, props, removeBooking };
  },
});
</script>

<style></style>
